CREATE TABLE `branch` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `version` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) DEFAULT NULL,
  `code` varchar(255) DEFAULT NULL,
  `current_working_date` date DEFAULT NULL,
  `branch_open_date` date DEFAULT NULL,
  `weekend_day_1` varchar(255) DEFAULT NULL,
  `weekend_day_2` varchar(255) DEFAULT NULL,
  `operational_status` varchar(255) DEFAULT NULL,
  `address_1` varchar(255) DEFAULT NULL,
  `address_2` varchar(255) DEFAULT NULL,
  `address_3` varchar(255) DEFAULT NULL,
  `country` varchar(255) DEFAULT NULL,
  `state` varchar(255) DEFAULT NULL,
  `city` varchar(255) DEFAULT NULL,
  `district` varchar(255) DEFAULT NULL,
  `pincode` varchar(255) DEFAULT NULL,
  `created_by` varchar(50) NOT NULL,
  `created_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `last_modified_by` varchar(50) DEFAULT NULL,
  `last_modified_date` timestamp NULL DEFAULT NULL,
  `partner_id` bigint(20) DEFAULT NULL,
  `location_1_id` varchar(100) DEFAULT NULL,
  `location_1_name` varchar(100) DEFAULT NULL,
  `location_2_id` varchar(100) DEFAULT NULL,
  `location_2_name` varchar(100) DEFAULT NULL,
  `location_3_id` varchar(100) DEFAULT NULL,
  `location_3_name` varchar(100) DEFAULT NULL,
  `location_4_id` varchar(100) DEFAULT NULL,
  `location_4_name` varchar(100) DEFAULT NULL,
  `location_5_id` varchar(100) DEFAULT NULL,
  `location_5_name` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `center` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `version` int(11) NOT NULL DEFAULT '0',
  `code` varchar(255) NOT NULL,
  `name` varchar(255) DEFAULT NULL,
  `branch_id` bigint(20) NOT NULL,
  `partner_id` bigint(20) NOT NULL,
  `created_by` varchar(50) NOT NULL,
  `created_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `last_modified_by` varchar(50) DEFAULT NULL,
  `last_modified_date` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`id`)
 ) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `customer` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `version` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) DEFAULT NULL,
  `partner_customer_id` varchar(100) DEFAULT NULL,
  `partner_id` bigint(20) DEFAULT NULL,
  `branch_id` bigint(20) DEFAULT NULL,
  `primary_mobile_number` bigint(20) DEFAULT NULL,
  `center_id` bigint(20) DEFAULT NULL,
  `is_test_customer` bit(1) DEFAULT 0,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `customer_subscriptions` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `version` int(11) NOT NULL DEFAULT '0',
  `customer_id` bigint(20) DEFAULT NULL,
  `subscription_date` date DEFAULT NULL,
  `start_date` date DEFAULT NULL,
  `end_date` date DEFAULT NULL,
  `product_note` varchar(1000) DEFAULT NULL,
  `contribution_amount` decimal(20,0) DEFAULT NULL,
  `final_contribution_amount` decimal(20,0) DEFAULT NULL,
  `frequency` varchar(100) DEFAULT NULL,
  `agreement_id` bigint(20) DEFAULT NULL,
  `status` enum('Active','Closed','Pending','InActive','PaymentActive','Started','CustomerReject','Pause','PendingClose') DEFAULT NULL,
  `created_by` varchar(50) DEFAULT NULL,
  `created_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `last_modified_by` varchar(50) DEFAULT NULL,
  `last_modified_date` timestamp NULL DEFAULT NULL,
  `solution` varchar(50) DEFAULT NULL,
  `contribution_period` varchar(45) DEFAULT NULL,
  `account_num` varchar(100) DEFAULT NULL,
  `next_contribution_date` date DEFAULT NULL,
  `solution_code` varchar(50) DEFAULT NULL,
  `partner_id` bigint(20) DEFAULT NULL,
  `enrollment_template_response_header_id` bigint(20) DEFAULT NULL,
  `payment_mode` enum('CASH','NACH','E_MANDATE','PAYROLL','PAYMENT_GATEWAY','NON_PAYMENT','BC') DEFAULT NULL,
  `nach_mandate_id` bigint(20) DEFAULT NULL,
  `goal` varchar(500) DEFAULT NULL,
  `goal_amount` decimal(20,0) DEFAULT NULL,
  `advisory_fee` decimal(10,0) DEFAULT NULL,
  `liquidity_card_enrollment_fee` decimal(10,0) DEFAULT NULL,
  `enroll_fee_paid_by_partner` decimal(10,0) DEFAULT NULL,
  `esign_id` bigint(20) DEFAULT NULL,
  `nach_review_status` enum('ACCEPT','REJECT','PENDING') DEFAULT NULL,
  `msa_review_status` enum('ACCEPT','REJECT','PENDING','NOT_REQUIRED') DEFAULT NULL,
  `nach_review_accepted_date` date DEFAULT NULL,
  `msa_review_accepted_date` date DEFAULT NULL,
  `flow_stage_bkup` enum('GOAL','QUESTIONNAIRE','PROFILE','RECOMMENDATION','POI','POA','SIGNATURE','PICTURE','IPV','PAYMENT') DEFAULT NULL,
  `flow_stage` int(11) DEFAULT '0',
  `last_modified_by_end_user` varchar(55) DEFAULT NULL,
  `customer_reject_date` timestamp NULL DEFAULT NULL,
  `customer_reject_channel` varchar(55) DEFAULT NULL,
  `nominee_details_id` bigint(20) DEFAULT NULL,
  `bank_detail_id` bigint(20) DEFAULT NULL,
  `frontend_status` enum('STARTED','COMPLETED','UNDER_RETRY','RETRY_COMPLETED') DEFAULT NULL,
  `frontend_status_date` datetime DEFAULT NULL,
  `backend_status` enum('STARTED','COMPLETED','UNDER_RETRY','RETRY_COMPLETED') DEFAULT NULL,
  `backend_status_date` datetime DEFAULT NULL,
  `subscription_type` enum('KF_GOAL','PARTNER_LOAN') DEFAULT NULL,
  `msa_reviewed_by` varchar(255) DEFAULT NULL,
  `nach_reviewed_by` varchar(255) DEFAULT NULL,
  `supported_payment_modes` varchar(255) DEFAULT NULL,
  `activated_payment_modes` varchar(255) DEFAULT NULL,
  `subscription_subtype` enum('DIGINACH') DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `demand` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `version` int(11) NOT NULL DEFAULT '0',
  `customer_id` bigint(20) DEFAULT NULL,
  `type` enum('INVESTMENT','KREDILINE_LOAN','ENROLLMENT','PARTNER_LOAN','LOAN') DEFAULT NULL,
  `type_id` bigint(20) DEFAULT NULL,
  `sub_type` enum('AdvisoryFee','LiquidityCardEnrollmentFee','DueAmount','Interest','Penalty','PrePayment','Fees','PreClosure') DEFAULT NULL,
  `demand_generation_type` enum('System','User') DEFAULT 'System',
  `status` enum('Pending','Processing','Processed') DEFAULT NULL,
  `demand_amount` decimal(10,0) DEFAULT NULL,
  `demand_raised_date` date NOT NULL,
  `demand_due_date` date NOT NULL,
  `demand_fulfilled_date` date DEFAULT NULL,
  `total_amount_collected` decimal(10,0) DEFAULT NULL,
  `correlation_id` varchar(36) DEFAULT NULL,
  `remarks` varchar(2000) DEFAULT NULL,
  `collection_transaction_id` bigint(20) DEFAULT NULL,
  `created_by` varchar(50) NOT NULL,
  `created_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `last_modified_by` varchar(50) DEFAULT NULL,
  `last_modified_date` timestamp NULL DEFAULT NULL,
  `routing_instruction` varchar(2048) DEFAULT NULL,
  `priority` int(11) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `demand_payment` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `version` int(11) NOT NULL DEFAULT '0',
  `demand_id` bigint(20) DEFAULT NULL,
  `payment_id` bigint(20) DEFAULT NULL,
  `fulfilled_amount` decimal(10,0) DEFAULT NULL,
  `status` enum('Pending','Processing','ReconPending','Success','Failure','Absent','Skipped','PaymentDelay','TestTransaction','Reminded','Cancelled') DEFAULT NULL,
  `created_by` varchar(50) NOT NULL,
  `created_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `last_modified_by` varchar(50) DEFAULT NULL,
  `last_modified_date` timestamp NULL DEFAULT NULL,
  `investment_status` enum('Pending','TransactionGenerated','NonInvestment') DEFAULT NULL,
  PRIMARY KEY (`id`),
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `employee` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `version` int(11) NOT NULL DEFAULT '0',
  `employee_id` varchar(50) NOT NULL,
  `user_id` bigint(20) DEFAULT NULL,
  `partner_id` bigint(20) NOT NULL,
  `name` varchar(255) DEFAULT NULL,
  `designation` varchar(255) DEFAULT NULL,
  `mobile_number` bigint(20) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `created_by` varchar(50) NOT NULL,
  `created_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `last_modified_by` varchar(50) DEFAULT NULL,
  `last_modified_date` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`id`),
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `employee_center` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `version` int(11) NOT NULL DEFAULT '0',
  `employee_id` bigint(20) NOT NULL,
  `center_id` bigint(20) NOT NULL,
  `created_by` varchar(50) NOT NULL,
  `created_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `last_modified_by` varchar(50) DEFAULT NULL,
  `last_modified_date` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`id`),
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `job_details` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `version` int(11) NOT NULL DEFAULT '0',
  `job_name` varchar(50) DEFAULT NULL,
  `job_configuration` text,
  `partner_id` bigint(20) DEFAULT NULL,
  `input_file_id` bigint(20) DEFAULT NULL,
  `output_file_id_1` bigint(20) DEFAULT NULL,
  `error_file_id_1` bigint(20) DEFAULT NULL,
  `total_count` bigint(20) DEFAULT '0',
  `success_count` bigint(20) DEFAULT '0',
  `failure_count` bigint(20) DEFAULT '0',
  `job_status` enum('Success','Failure','Processed','Execute','Ready','Cancelled','Processing') DEFAULT NULL,
  `uploaded_date` date DEFAULT NULL,
  `created_by` varchar(50) NOT NULL,
  `created_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `last_modified_by` varchar(50) DEFAULT NULL,
  `last_modified_date` timestamp NULL DEFAULT NULL,
  `output_file_id_2` bigint(20) DEFAULT NULL,
  `output_file_id_3` bigint(20) DEFAULT NULL,
  `error_file_id_2` bigint(20) DEFAULT NULL,
  `error_file_id_3` bigint(20) DEFAULT NULL,
  `job_type` enum('FileGeneration','FileProcessing') DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `nach_mandate` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `version` int(11) NOT NULL DEFAULT '0',
  `bank_name` varchar(255) DEFAULT NULL,
  `ifsc_code` varchar(45) DEFAULT NULL,
  `bank_account_id` varchar(100) DEFAULT NULL,
  `customer_id` bigint(20) DEFAULT NULL,
  `start_date` date DEFAULT NULL,
  `end_date` date DEFAULT NULL,
  `registration_date` date DEFAULT NULL,
  `transaction_id` varchar(255) DEFAULT NULL,
  `request_json` text,
  `registration_resp_json` text,
  `verification_resp_json` text,
  `status_code` varchar(255) DEFAULT NULL,
  `status_message` varchar(1000) DEFAULT NULL,
  `status` enum('PENDING','PROCESSING','NA','SUCCESS','FAILURE') DEFAULT NULL,
  `created_by` varchar(50) NOT NULL,
  `created_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `last_modified_by` varchar(50) DEFAULT NULL,
  `last_modified_date` timestamp NULL DEFAULT NULL,
  `verification_request_json` text,
  `verification_url` varchar(100) DEFAULT NULL,
  `consumer_id` bigint(20) DEFAULT NULL,
  `mandate_reg_no` varchar(50) DEFAULT NULL,
  `bank_account_holder_name` varchar(50) DEFAULT NULL,
  `branch_name` varchar(100) DEFAULT NULL,
  `micr` varchar(50) DEFAULT NULL,
  `account_type` varchar(50) DEFAULT NULL,
  `nach_mode` enum('ONLINE','OFFLINE') DEFAULT NULL,
  `bank_code` varchar(50) DEFAULT NULL,
  `form_no` varchar(50) DEFAULT NULL,
  `generated_nach_file_id` bigint(20) DEFAULT NULL,
  `is_emandate` bit(1) NOT NULL DEFAULT 0,
  `emandate_id` bigint(20) DEFAULT NULL,
  `nach_max_amount` bigint(20) DEFAULT NULL,
  `verification_status` varchar(100) DEFAULT NULL,
  `review_date` date DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `partner` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `version` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL,
  `code` varchar(255) NOT NULL,
  `created_by` varchar(50) NOT NULL,
  `created_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `last_modified_by` varchar(50) DEFAULT NULL,
  `last_modified_date` timestamp NULL DEFAULT NULL,
  `partner_customer_id_mandatory` bit(1) NOT NULL,
  `cash_collection_mode` enum('Deferred','Immediate') DEFAULT NULL,
  `compute_contribution_amount` bit(1) DEFAULT NULL,
  `owner` bit(1) DEFAULT NULL,
  `cb_check_required` bit(1) DEFAULT 1,
  `default_response` mediumtext,
  `min_first_contribution_amount_required` bit(1) DEFAULT NULL,
  `min_first_contribution_amount` decimal(10,0) DEFAULT NULL,
  `first_admin_fee_inclusive` bit(1) DEFAULT NULL,
  `recurring_admin_fee_inclusive` bit(1) DEFAULT NULL,
  `customer_payment_mode` varchar(255) DEFAULT NULL,
  `pay_date` int(11) DEFAULT NULL,
  `contribution_amount_multiples_of` int(11) DEFAULT NULL,
  `helpline_number` varchar(255) DEFAULT NULL,
  `payment_dates` varchar(50) NOT NULL,
  `skip_cycle` enum('HALF','FULL','NONE') NOT NULL DEFAULT 'NONE',
  `future_collections_range` int(11) NOT NULL DEFAULT '7',
  `min_goal_amount` decimal(10,0) DEFAULT NULL,
  `min_goal_tenure` int(11) DEFAULT NULL,
  `partner_status` varchar(50) DEFAULT NULL,
  `maximum_number_of_invitations` int(11) DEFAULT NULL,
  `invitation_expiry_days` int(11) DEFAULT NULL,
  `last_invitation_sent_date` date DEFAULT NULL,
  `invitation_frequency` int(11) DEFAULT NULL,
  `sub_domain` varchar(255) DEFAULT NULL,
  `file_id` bigint(20) DEFAULT NULL,
  `signzy_configuration` int(11) NOT NULL DEFAULT '1',
  `name_partner_customer_id` enum('NAME','ID') NOT NULL DEFAULT 'NAME',
  `type_of_partner` varchar(45) DEFAULT NULL,
  `enrollment_fee_by_percentage` int(11) DEFAULT '0',
  `ui_flow_configuration` varchar(1000) DEFAULT NULL,
  `is_partner_specific_advisory_fee` tinyint(1) DEFAULT '0',
  `max_goal_tenure` int(11) DEFAULT '0',
  `max_contribution_amount` decimal(20,0) DEFAULT NULL,
  `scheme_code` varchar(50) DEFAULT NULL,
  `auto_review_configuration` text,
  `nach_max_amount` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `payment` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `version` int(11) NOT NULL DEFAULT '0',
  `payment_date` date DEFAULT NULL,
  `total_amount` decimal(10,0) DEFAULT NULL,
  `payment_mode` enum('CASH','NACH','E_MANDATE','PAYROLL','PAYMENT_GATEWAY','NON_PAYMENT','BC') DEFAULT NULL,
  `transaction_reference_id` varchar(50) DEFAULT NULL,
  `status` enum('Pending','Success','Failure','Processing','Absent','Skipped','PaymentDelay','TestTransaction','Reminded','Cancelled') DEFAULT NULL,
  `remarks` varchar(2000) DEFAULT NULL,
  `payment_reconciliation_id` bigint(20) DEFAULT NULL,
  `recon_status` enum('ReconPending','ReconIssue','ReconComplete','ReconIgnored') DEFAULT NULL,
  `recon_date` timestamp NULL DEFAULT NULL,
  `created_by` varchar(50) NOT NULL,
  `created_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `last_modified_by` varchar(50) DEFAULT NULL,
  `last_modified_date` timestamp NULL DEFAULT NULL,
  `routing_instruction_summary` varchar(1024) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
